*Ibrahim Kucukkoc, PhD, http://ikucukkoc.baun.edu.tr
*Mixed-model Straight Assembly Line Balancing Problem
*8-task, type-I, Slide 8 Page 25 / Tutorial Question #4

option mip = cplex;
Option optcr = 0.00;
Option optca = 0.00;
Option reslim = 7200;
Option iterlim = 1e09;


Sets
 i index of tasks  /1*8/
 j index of workstations  /1*2/
 m index of models /1*2/
;

alias (i,r,s)
;

scalar C cycle time;
 C=15
;

table
 t(i,m)   Operation time of task i for model m
    1  2
 1  5  3
 2  1  5
 3  6  0
 4  0  1
 5  2  6
 6  0  4
 7  4  2
 8  3  5
;


*only immediate predecessors/sadece komsu ncller
parameter
  P(r,s)     Set of immediate precedence relationships for precedence diagram;
P("1","2")=1;
P("1","4")=1;
P("1","3")=1;
P("2","5")=1;
P("2","7")=1;
P("3","7")=1;
P("4","8")=1;
P("5","6")=1;
P("6","8")=1;
P("7","8")=1;


variables
  obj        objective  ;

binary variables
  x(i,j)  if task i is assigned to station j
  Z(j)    if station j is utilized
  ;

Equation
  Objective
  con1 assignment constraint -atama kisiti
  con2 cycle time constraint -cevrim zamani kisiti
  con3 precedence relationship constraint -cevrim zamani kisiti
  ;

***********Balancing*******************************
  Objective.. obj=e=sum(j,z(j));

  con1(i).. sum(j,x(i,j))=e=1;

  con2(m,j).. sum(i,x(i,j)*t(i,m)) =l= C*z(j);

  con3(r,s)$(P(r,s)).. sum(j, ord(j)*x(r,j) - ord(j)*x(s,j)) =l= 0;

**********************************************************************************
model  assembly/all/;
solve  assembly minimizing obj using MIP;
display obj.l;
display x.l,Z.l;

******************************************
